import { OkuElement, PrimitiveProps } from '@oku-ui/primitive';
import * as vue from 'vue';
import * as _oku_ui_provide from '@oku-ui/provide';

type CheckboxNativeElement = Omit<OkuElement<'button', true>, 'checked' | 'defaultChecked'>;
type CheckboxElement = HTMLButtonElement;
type CheckedState = boolean | 'indeterminate';
interface CheckboxProps extends PrimitiveProps {
    checked?: CheckedState;
    defaultChecked?: CheckedState;
    required?: boolean;
    name?: string;
    disabled?: boolean;
    value?: string;
    modelValue?: CheckedState;
}
type CheckboxEmits = {
    'update:modelValue': [checked: CheckedState];
    'checkedChange': [checked: CheckedState];
    'keydown': [event: KeyboardEvent];
    'click': [event: MouseEvent];
};
type CheckboxIndicatorNativeElement = OkuElement<'span'>;
type CheckboxIndicatorElement = HTMLSpanElement;
interface CheckboxIndicatorProps extends PrimitiveProps {
    forceMount?: true;
}

declare const OkuCheckbox: {
    new (...args: any[]): vue.CreateComponentPublicInstance<Readonly<vue.ExtractPropTypes<{
        scopeOkuCheckbox: {
            type: vue.PropType<_oku_ui_provide.Scope<any>>;
            required: boolean;
        };
        asChild: BooleanConstructor;
        modelValue: {
            type: vue.PropType<CheckedState | undefined>;
            default: undefined;
        };
        checked: {
            type: vue.PropType<CheckedState | undefined>;
            default: undefined;
        };
        defaultChecked: {
            type: vue.PropType<CheckedState | undefined>;
            default: undefined;
        };
        required: {
            type: vue.PropType<boolean | undefined>;
        };
        name: {
            type: vue.PropType<string | undefined>;
        };
        disabled: {
            type: vue.PropType<boolean | undefined>;
        };
        value: {
            type: vue.PropType<string | undefined>;
            default: string;
        };
    }>> & {
        onKeydown?: ((event: KeyboardEvent) => any) | undefined;
        onClick?: ((event: MouseEvent) => any) | undefined;
        "onUpdate:modelValue"?: ((checked: CheckedState) => any) | undefined;
        onCheckedChange?: ((checked: CheckedState) => any) | undefined;
    }, () => (false | vue.VNode<vue.RendererNode, vue.RendererElement, {
        [key: string]: any;
    }>)[], unknown, {}, {}, vue.ComponentOptionsMixin, vue.ComponentOptionsMixin, {
        'update:modelValue': (checked: CheckedState) => boolean;
        checkedChange: (checked: CheckedState) => boolean;
        keydown: (event: KeyboardEvent) => boolean;
        click: (event: MouseEvent) => boolean;
    }, vue.VNodeProps & vue.AllowedComponentProps & vue.ComponentCustomProps & Readonly<vue.ExtractPropTypes<{
        scopeOkuCheckbox: {
            type: vue.PropType<_oku_ui_provide.Scope<any>>;
            required: boolean;
        };
        asChild: BooleanConstructor;
        modelValue: {
            type: vue.PropType<CheckedState | undefined>;
            default: undefined;
        };
        checked: {
            type: vue.PropType<CheckedState | undefined>;
            default: undefined;
        };
        defaultChecked: {
            type: vue.PropType<CheckedState | undefined>;
            default: undefined;
        };
        required: {
            type: vue.PropType<boolean | undefined>;
        };
        name: {
            type: vue.PropType<string | undefined>;
        };
        disabled: {
            type: vue.PropType<boolean | undefined>;
        };
        value: {
            type: vue.PropType<string | undefined>;
            default: string;
        };
    }>> & {
        onKeydown?: ((event: KeyboardEvent) => any) | undefined;
        onClick?: ((event: MouseEvent) => any) | undefined;
        "onUpdate:modelValue"?: ((checked: CheckedState) => any) | undefined;
        onCheckedChange?: ((checked: CheckedState) => any) | undefined;
    }, {
        value: string | undefined;
        checked: CheckedState | undefined;
        defaultChecked: CheckedState | undefined;
        modelValue: CheckedState | undefined;
        asChild: boolean;
    }, true, {}, {}, {
        P: {};
        B: {};
        D: {};
        C: {};
        M: {};
        Defaults: {};
    }, Readonly<vue.ExtractPropTypes<{
        scopeOkuCheckbox: {
            type: vue.PropType<_oku_ui_provide.Scope<any>>;
            required: boolean;
        };
        asChild: BooleanConstructor;
        modelValue: {
            type: vue.PropType<CheckedState | undefined>;
            default: undefined;
        };
        checked: {
            type: vue.PropType<CheckedState | undefined>;
            default: undefined;
        };
        defaultChecked: {
            type: vue.PropType<CheckedState | undefined>;
            default: undefined;
        };
        required: {
            type: vue.PropType<boolean | undefined>;
        };
        name: {
            type: vue.PropType<string | undefined>;
        };
        disabled: {
            type: vue.PropType<boolean | undefined>;
        };
        value: {
            type: vue.PropType<string | undefined>;
            default: string;
        };
    }>> & {
        onKeydown?: ((event: KeyboardEvent) => any) | undefined;
        onClick?: ((event: MouseEvent) => any) | undefined;
        "onUpdate:modelValue"?: ((checked: CheckedState) => any) | undefined;
        onCheckedChange?: ((checked: CheckedState) => any) | undefined;
    }, () => (false | vue.VNode<vue.RendererNode, vue.RendererElement, {
        [key: string]: any;
    }>)[], {}, {}, {}, {
        value: string | undefined;
        checked: CheckedState | undefined;
        defaultChecked: CheckedState | undefined;
        modelValue: CheckedState | undefined;
        asChild: boolean;
    }>;
    __isFragment?: undefined;
    __isTeleport?: undefined;
    __isSuspense?: undefined;
} & vue.ComponentOptionsBase<Readonly<vue.ExtractPropTypes<{
    scopeOkuCheckbox: {
        type: vue.PropType<_oku_ui_provide.Scope<any>>;
        required: boolean;
    };
    asChild: BooleanConstructor;
    modelValue: {
        type: vue.PropType<CheckedState | undefined>;
        default: undefined;
    };
    checked: {
        type: vue.PropType<CheckedState | undefined>;
        default: undefined;
    };
    defaultChecked: {
        type: vue.PropType<CheckedState | undefined>;
        default: undefined;
    };
    required: {
        type: vue.PropType<boolean | undefined>;
    };
    name: {
        type: vue.PropType<string | undefined>;
    };
    disabled: {
        type: vue.PropType<boolean | undefined>;
    };
    value: {
        type: vue.PropType<string | undefined>;
        default: string;
    };
}>> & {
    onKeydown?: ((event: KeyboardEvent) => any) | undefined;
    onClick?: ((event: MouseEvent) => any) | undefined;
    "onUpdate:modelValue"?: ((checked: CheckedState) => any) | undefined;
    onCheckedChange?: ((checked: CheckedState) => any) | undefined;
}, () => (false | vue.VNode<vue.RendererNode, vue.RendererElement, {
    [key: string]: any;
}>)[], unknown, {}, {}, vue.ComponentOptionsMixin, vue.ComponentOptionsMixin, {
    'update:modelValue': (checked: CheckedState) => boolean;
    checkedChange: (checked: CheckedState) => boolean;
    keydown: (event: KeyboardEvent) => boolean;
    click: (event: MouseEvent) => boolean;
}, string, {
    value: string | undefined;
    checked: CheckedState | undefined;
    defaultChecked: CheckedState | undefined;
    modelValue: CheckedState | undefined;
    asChild: boolean;
}, {}, string, {}> & vue.VNodeProps & vue.AllowedComponentProps & vue.ComponentCustomProps & (new () => {
    $props: CheckboxNativeElement;
});

declare const OkuCheckboxIndicator: {
    new (...args: any[]): vue.CreateComponentPublicInstance<Readonly<vue.ExtractPropTypes<{
        scopeOkuCheckbox: {
            type: vue.PropType<_oku_ui_provide.Scope<any>>;
            required: boolean;
        };
        asChild: BooleanConstructor;
        forceMount: {
            type: vue.PropType<true | undefined>;
            default: undefined;
        };
    }>>, () => vue.VNode<vue.RendererNode, vue.RendererElement, {
        [key: string]: any;
    }>, unknown, {}, {}, vue.ComponentOptionsMixin, vue.ComponentOptionsMixin, {}, vue.VNodeProps & vue.AllowedComponentProps & vue.ComponentCustomProps & Readonly<vue.ExtractPropTypes<{
        scopeOkuCheckbox: {
            type: vue.PropType<_oku_ui_provide.Scope<any>>;
            required: boolean;
        };
        asChild: BooleanConstructor;
        forceMount: {
            type: vue.PropType<true | undefined>;
            default: undefined;
        };
    }>>, {
        forceMount: true | undefined;
        asChild: boolean;
    }, true, {}, {}, {
        P: {};
        B: {};
        D: {};
        C: {};
        M: {};
        Defaults: {};
    }, Readonly<vue.ExtractPropTypes<{
        scopeOkuCheckbox: {
            type: vue.PropType<_oku_ui_provide.Scope<any>>;
            required: boolean;
        };
        asChild: BooleanConstructor;
        forceMount: {
            type: vue.PropType<true | undefined>;
            default: undefined;
        };
    }>>, () => vue.VNode<vue.RendererNode, vue.RendererElement, {
        [key: string]: any;
    }>, {}, {}, {}, {
        forceMount: true | undefined;
        asChild: boolean;
    }>;
    __isFragment?: undefined;
    __isTeleport?: undefined;
    __isSuspense?: undefined;
} & vue.ComponentOptionsBase<Readonly<vue.ExtractPropTypes<{
    scopeOkuCheckbox: {
        type: vue.PropType<_oku_ui_provide.Scope<any>>;
        required: boolean;
    };
    asChild: BooleanConstructor;
    forceMount: {
        type: vue.PropType<true | undefined>;
        default: undefined;
    };
}>>, () => vue.VNode<vue.RendererNode, vue.RendererElement, {
    [key: string]: any;
}>, unknown, {}, {}, vue.ComponentOptionsMixin, vue.ComponentOptionsMixin, {}, string, {
    forceMount: true | undefined;
    asChild: boolean;
}, {}, string, {}> & vue.VNodeProps & vue.AllowedComponentProps & vue.ComponentCustomProps & (new () => {
    $props: CheckboxIndicatorNativeElement;
});

export { type CheckboxElement, type CheckboxEmits, type CheckboxIndicatorElement, type CheckboxIndicatorNativeElement, type CheckboxIndicatorProps, type CheckboxNativeElement, type CheckboxProps, OkuCheckbox, OkuCheckboxIndicator };
